import re, os
from collections import OrderedDict

#'''
geneticCode = {
            'TCA' : '<span class=ser>CODON</span>',    #'S',    # ser
            'TCC' : '<span class=ser>CODON</span>',    #'S',    # ser
            'TCG' : '<span class=ser>CODON</span>',    #'S',    # ser
            'TCT' : '<span class=ser>CODON</span>',    #'S',    # ser
            'TTC' : '<span class=phe>CODON</span>',    # F
            'TTT' : '<span class=phe>CODON</span>',    #'F',    # phe
            'TTA' : '<span class=leu>CODON</span>',    #'L',    # leu
            'TTG' : '<span class=leu>CODON</span>',    #'L',    # leu
            'TAC' : '<span class=tyr>CODON</span>',    #'Y',    # tyr
            'TAT' : '<span class=tyr>CODON</span>',    #'Y',    # tyr
            'TAA' : '<span class=stp>CODON</span>',    #'*',    # stp
            'TAG' : '<span class=stp>CODON</span>',    #'*',    # stp
            'TGC' : '<span class=cys>CODON</span>',    #'C',    # cys
            'TGT' : '<span class=cys>CODON</span>',    #'C',    # cys
            'TGA' : '<span class=stp>CODON</span>',    #'*',    # stp
            'TGG' : '<span class=trp>CODON</span>',    #'W',    # trp
            'CTA' : '<span class=leu>CODON</span>',    #'L',    # leu
            'CTC' : '<span class=leu>CODON</span>',    #'L',    # leu
            'CTG' : '<span class=leu>CODON</span>',    #'L',    # leu
            'CTT' : '<span class=leu>CODON</span>',    #'L',    # leu
            'CCA' : '<span class=pro>CODON</span>',    #'P',    # pro
            'CCC' : '<span class=pro>CODON</span>',    #'P',    # pro
            'CCG' : '<span class=pro>CODON</span>',    #'P',    # pro
            'CCT' : '<span class=pro>CODON</span>',    #'P',    # pro
            'CAC' : '<span class=his>CODON</span>',    #'H',    # his
            'CAT' : '<span class=his>CODON</span>',    #'H',    # his
            'CAA' : '<span class=gln>CODON</span>',    #'Q',    # gln
            'CAG' : '<span class=gln>CODON</span>',    #'Q',    # gln
            'CGA' : '<span class=arg>CODON</span>',    #'R',    # arg
            'CGC' : '<span class=arg>CODON</span>',    #'R',    # arg
            'CGG' : '<span class=arg>CODON</span>',    #'R',    # arg
            'CGT' : '<span class=arg>CODON</span>',    #'R',    # arg
            'ATA' : '<span class=ile>CODON</span>',    #'I',    # ile
            'ATC' : '<span class=ile>CODON</span>',    #'I',    # ile
            'ATT' : '<span class=ile>CODON</span>',    #'I',    # ile
            'ATG' : '<span class=met>CODON</span>',    #'M',    # met
            'ACA' : '<span class=thr>CODON</span>',    #'T',    # thr
            'ACC' : '<span class=thr>CODON</span>',    #'T',    # thr
            'ACG' : '<span class=thr>CODON</span>',    #'T',    # thr
            'ACT' : '<span class=thr>CODON</span>',    #'T',    # thr
            'AAC' : '<span class=asn>CODON</span>',    #'N',    # asn
            'AAT' : '<span class=asn>CODON</span>',    #'N',    # asn
            'AAA' : '<span class=lys>CODON</span>',    #'K',    # lys
            'AAG' : '<span class=lys>CODON</span>',    #'K',    # lys
            'AGC' : '<span class=ser>CODON</span>',    #'S',    # ser
            'AGT' : '<span class=ser>CODON</span>',    #'S',    # ser
            'AGA' : '<span class=arg>CODON</span>',    #'R',    # arg
            'AGG' : '<span class=arg>CODON</span>',    #'R',    # arg
            'GTA' : '<span class=val>CODON</span>',    #'V',    # val
            'GTC' : '<span class=val>CODON</span>',    #'V',    # val
            'GTG' : '<span class=val>CODON</span>',    #'V',    # val
            'GTT' : '<span class=val>CODON</span>',    #'V',    # val
            'GCA' : '<span class=ala>CODON</span>',    #'A',    # ala
            'GCC' : '<span class=ala>CODON</span>',    #'A',    # ala
            'GCG' : '<span class=ala>CODON</span>',    #'A',    # ala
            'GCT' : '<span class=ala>CODON</span>',    #'A',    # ala
            'GAC' : '<span class=asp>CODON</span>',    #'D',    # asp
            'GAT' : '<span class=asp>CODON</span>',    #'D',    # asp
            'GAA' : '<span class=glu>CODON</span>',    #'E',    # glu
            'GAG' : '<span class=glu>CODON</span>',    #'E',    # glu
            'GGA' : '<span class=gly>CODON</span>',    #'G',    # gly
            'GGC' : '<span class=gly>CODON</span>',    #'G',    # gly
            'GGG' : '<span class=gly>CODON</span>',    #'G',    # gly
            'GGT' : '<span class=gly>CODON</span>',    #'G',    # gly
}
#'''

'''
## from pal2nal
geneticCode = {
            "((U|T|C|Y|A)(U|T)G)"               : '<span class=met>CODON</span>',
            "((C(U|T).)|((U|T)(U|T)(A|G|R)))"   : '<span class=leu>CODON</span>',
            "((CG.)|(AG(A|G|R)))"               : '<span class=arg>CODON</span>',
            "(((U|T)C.)|(AG(U|T|C|Y)))"         : '<span class=ser>CODON</span>',
            "(GC.)"                             : '<span class=ala>CODON</span>',
            "(GG.)"                             : '<span class=gly>CODON</span>',
            "(CC.)"                             : '<span class=pro>CODON</span>',
            "(AC.)"                             : '<span class=thr>CODON</span>',
            "(G(U|T).)"                         : '<span class=val>CODON</span>',
            "(A(U|T)(U|T|C|Y|A))"               : '<span class=ile>CODON</span>',
            "(((U|T)A(A|G|R))|((T|U)GA))"       : 'CODON',
            "(((U|T)A(A|G|R))|((T|U)GA))"       : '<span class=stp>CODON</span>',  ##  "*"
            "((U|T)G(U|T|C|Y))"                 : '<span class=cys>CODON</span>',
            "(GA(U|T|C|Y))"                     : '<span class=asp>CODON</span>',
            "(GA(A|G|R))"                       : '<span class=glu>CODON</span>',
            "((U|T)(U|T)(U|T|C|Y))"             : '<span class=phe>CODON</span>',
            "(CA(U|T|C|Y))"                     : '<span class=his>CODON</span>',
            "(AA(A|G|R))"                       : '<span class=lys>CODON</span>',
            "(AA(U|T|C|Y))"                     : '<span class=asn>CODON</span>',
            "(CA(A|G|R))"                       : '<span class=gln>CODON</span>',
            "((U|T)A(U|T|C|Y))"                 : '<span class=tyr>CODON</span>',
            "(A(U|T)G)"                         : '<span class=met>CODON</span>',
            "((U|T)GG)"                         : '<span class=trp>CODON</span>',
#            "..."                              : 'CODON',
            "(NNN)"                             : 'CODON',
            "(N(.|N).)"                         : 'CODON',
            "(.(.|N)N)"                         : 'CODON',
            "(.N.)"                             : 'CODON'
}
'''

top = '''
<!DOCTYPE html>
<html>
<head>
    <meta http-equiv="Content-Type" content="text/html">
        <title>TITLE</title>
            <style type="text/css">
                .ala { background-color: #ff00ff; }
                .arg { background-color: #ff0080; }
                .asn { background-color: #0080ff; }
                .asp { background-color: #00ffff; }
                .cys { background-color: #80ff00; }
                .gln { background-color: #ffff00; }
                .glu { background-color: #ffffdf; }
                .gly { background-color: #7f7f7f; }
                .his { background-color: #ff80ff; }
                .ile { background-color: #ff80c0; }
                .leu { background-color: #80bfff; }
                .lys { background-color: #80ffff; }
                .met { background-color: #80ff80; }
                .phe { background-color: #ffff80; }
                .pro { background-color: #ff8080; }
                .ser { background-color: #bfbfbf; }
                .thr { background-color: #ffbfff; }
                .tyr { background-color: #ffbfdf; }
                .trp { background-color: #bfdfff; }
                .val { background-color: #bfffff; }
                .stp { background-color: #000000; color: white}
            </style>
    </head>
<body>
<pre>'''

bottom = '''
</pre>
</body>
</html>'''


def interleavedMake(cDNAorAA, keyNameFN, keySequenceFN, oneLineLength, recsFN):
    siteNum  = 1
    startPos = 0
    stopPos  = 0
    sequenceLengthFN = len(list(recsFN.values())[0])
    linesFN  = []
    for i in range(sequenceLengthFN):
        if i > 1 and i % oneLineLength == 0:
            startPos = i - oneLineLength
            stopPos = startPos + oneLineLength
            #print("siteNum :", startPos + 1)
            #print("startPos:", startPos)
            #print("stopPos :", stopPos)
            #for j in range(startPos, stopPos):
            #    print(str(j) + ",", end="")
            #print()
            recOneLines = recOneLinesMaker(cDNAorAA, keyNameFN, keySequenceFN, startPos, stopPos, recsFN)
            for line in recOneLines:
                linesFN.append(line)
            linesFN.append("\n")

    #print("siteNum :", stopPos + 1)
    #print("startPos:", stopPos)
    #print("stopPos :", sequenceLengthFN)
    #for i in range(stopPos, sequenceLengthFN):
    #    print(str(i) + ",", end="")
    #print()
    recOneLines = recOneLinesMaker(cDNAorAA, keyNameFN, keySequenceFN, stopPos, sequenceLengthFN, recsFN)
    for line in recOneLines:
        linesFN.append(line)
    linesFN.append("\n")
    return(linesFN)
    
    
def htmlFileMake(linesFN, keySequenceFN, outFileFN):
    sequenceLength = len(keySequenceFN)
    out = open(outFileFN, "w")
    out.write(top)
    out.write(str(sequenceLength) + "\n")
    for line in linesFN:
        out.write(line)
    out.write(bottom)
    out.close()


def recOneLinesMaker(cDNAorAA, keyNameFN, keySequenceFN, startPosNF, stopPosNF, recsFN):

    htmlOneLines = []

    longestNameLen = len(max(recsFN.keys(), key = len))
    NumberLine = " " * (longestNameLen) + str(startPosNF+1) + "\n"
    htmlOneLines.append(NumberLine)

    for name in recsFN.keys():
        htmlOneLine = name
        if cDNAorAA == "cDNA":
            for p in range(startPosNF, stopPosNF, 3):
                if p+2 <= stopPosNF:
                    keySpCodon = keySequenceFN[p] + keySequenceFN[p+1] + keySequenceFN[p+2]
                    codon      = recsFN[name][p]  + recsFN[name][p+1]  + recsFN[name][p+2]
                    codonHTML  = codonHTMLStylePicker(keyNameFN, keySpCodon, name, codon)
                    htmlOneLine += codonHTML
        elif cDNAorAA == "AA":
            for p in range(startPosNF, stopPosNF):
                keySpAA = keySequenceFN[p]
                AA      = recsFN[name][p]
                aaHTML  = matchFirsterAA (keyNameFN, keySpAA, name, AA)
                htmlOneLine += aaHTML
        else:
            print("Select cDNAorAA. Stopped.")
            exit()
        
        keyNameFN_NS = re.sub("^>", "", keyNameFN)
        if re.search(keyNameFN_NS, name):
            htmlOneLine = "<u>" + htmlOneLine + "</u>"
        
        htmlOneLine += "\n"
        htmlOneLines.append(htmlOneLine)

    return htmlOneLines


def matchFirsterCodon (keyNameFN, keyCodonFN, nameFN, codonFN):
    codonFNmod = ""
    nameFN = ">" + nameFN
    if re.search(keyNameFN, nameFN):
        codonFNmod = codonFN
    else:
        for i in range(0,3):
            if keyCodonFN[i] == "X" or keyCodonFN[i] == "-" or keyCodonFN[i] == "N":
                codonFNmod += codonFN[i]
            elif keyCodonFN[i] == codonFN[i]:
                codonFNmod += "."
            else:
                codonFNmod += codonFN[i]
    return codonFNmod


def matchFirsterAA (keyNameFN, keySpAAFN, nameFN, AAFN):
    AAFNmod = ""
    nameFN = ">" + nameFN
    if re.search(keyNameFN, nameFN):
        AAFNmod = AAFN
    else:
        if AAFN == "X" or AAFN == "-":
            AAFNmod += AAFN
        elif keySpAAFN == AAFN:
            AAFNmod += "."
        else:
            AAFNmod += AAFN
    return AAFNmod


def codonHTMLStylePicker(keyNameFN, keySpCodonFN, nameFN, codonFN):
    codonLineFN = ""
    selectedAA = []
    
    #'''
    hitCodes = [geneticCode.keys()]
    hitNames = [codonHTML for codonHTML in geneticCode.keys() if re.search(codonFN, codonHTML)]

    if hitNames:
        #print(hitNames)
        codonLineFN = geneticCode[hitNames[0]]
    else:
        #print("Not hit.")
        codonLineFN = "CODON"

    '''
    if len(hitNames) > 1:
        print("More than 2 hits.Stopped.")
        print(hitNames)
        exit()
    elif len(hitNames) == 1:
        #print("1 hit.")
        #print(hitNames)
        codonLineFN = geneticCode[hitNames[0]]
    else:
        #print("Not hit.")
        codonLineFN = "CODON"
    '''

    '''
    for key in geneticCode:
        if re.match(key, codonFN):
            selectedAA.append(geneticCode.get(key))
    ##  B or M
    if len(selectedAA) > 1:
        codonLineFN = selectedAA[1]
    elif len(selectedAA) == 1:
        codonLineFN = selectedAA[0]
    else:
        codonLineFN = "CODON"
    '''

    codonFN2 = matchFirsterCodon(keyNameFN, keySpCodonFN, nameFN, codonFN)

    codonLineFN = re.sub("CODON", codonFN2, codonLineFN)
    return codonLineFN


def keySpeciesPicker(keySpeciesFN, recsFN):
    keyWord = ">" + keySpeciesFN
    hitNames = [name for name in recsFN.keys() if re.search(keyWord, name)]
    if len(hitNames) > 1:
        print("More than 2 keySpecies:%s. Stopped." % keySpeciesFN)
        exit()
    elif len(hitNames) == 0:
        print("No keySpecies:%s. Stopped." % keySpeciesFN)
        exit()
    else:
        return hitNames[0], recsFN[hitNames[0]]


def readFasta_dict(dirAddress, InfileNameFN):
    Infile = open(dirAddress+InfileNameFN, "r")
    seqDictFN  = OrderedDict()
    for Line in Infile:
        Line = Line.rstrip("\n")
        if Line[0] == ">":
            Name            = Line
            seqDictFN[Name] = ""
        else:
            seqDictFN[Name] += Line.upper()
    Infile.close()
    return seqDictFN


def whiteSpaceAdd(recsFN1):
    longestNameLen = len(max(recsFN1.keys(), key = len))
    recsFN2        = OrderedDict()
    for name,value in recsFN1.items():
        nameWhiteSpace = name[1:] + " " * (longestNameLen - len(name) + 2)
        recsFN2[nameWhiteSpace] = value
    return recsFN2


#### Main program

cDNAorAA = "cDNA"
#cDNAorAA = "AA"

inFile  = "fastaFile_cDNA.txt"
#inFile   = "fastaFile_AA.txt"

outFile = inFile + ".html"

oneLineLength         = 90         ## For cDNA, needs to be a multiple of 3
keySpecies            = "QuerySequence"
recs                  = readFasta_dict("./", inFile)
keyName, keySequence  = keySpeciesPicker(keySpecies, recs)
recs                  = whiteSpaceAdd(recs)
lines                 = interleavedMake(cDNAorAA, keyName, keySequence, oneLineLength, recs)
htmlFileMake(lines, keySequence, outFile)

